﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Media;

namespace MorseCode2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        Dictionary<String,String> MorseCodeDictionary = new Dictionary<string,string>();

        private void Form1_Load(object sender, EventArgs e)
        {
            MorseCodeDictionary.Add(".-","A");
            MorseCodeDictionary.Add("...","S");
            MorseCodeDictionary.Add("---","O");
        }


        DateTime mouseDownTime = DateTime.MaxValue;
        DateTime mouseUpTime = DateTime.MaxValue;
        bool mouseIsDown = false;
        private void button1_MouseDown(object sender, MouseEventArgs e)
        {
            mouseDownTime = DateTime.Now;
            mouseIsDown = true;
        }

        private void button1_MouseUp(object sender, MouseEventArgs e)
        {
            mouseIsDown = false;
            mouseUpTime = DateTime.Now;
            TimeSpan span = DateTime.Now.Subtract(mouseDownTime);
            if(span.Milliseconds > 250)
            {
                lblCodes.Text += "-";
                //(new SoundPlayer(@"c:\dot.wav")).Play();
            }
            else 
            {
                lblCodes.Text += ".";
                //(new SoundPlayer(@"c:\dash.wav")).Play();
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {

            if(mouseUpTime != DateTime.MaxValue && !mouseIsDown)
            {
                TimeSpan span = DateTime.Now.Subtract(mouseUpTime);
                if(span.Milliseconds > 500)
                {
                    if (MorseCodeDictionary.ContainsKey(lblCodes.Text))
                    {
                        lblResult.Text += MorseCodeDictionary[lblCodes.Text];
                        button1.BackColor = Color.Green;
                    }
                    else
                    {
                        if (lblCodes.Text != "")
                        {
                            (new SoundPlayer(@"c:\no.wav")).Play();
                            button1.BackColor = Color.Red;
                        }
                    }
                    lblCodes.Text = "";
                }
            }
        }
    }
}
